import { TextInputSelectionChangeEventData, TextInputProps } from 'react-native';
export declare type ATRange = TextInputSelectionChangeEventData['selection'];
export declare type ATUser = {
    username: string;
    id: string | number;
};
export declare type ATMap = Map<[number, number], ATUser>;
export declare type ATChangeData = {
    displayText: string;
    text: string;
    users: ATUser[];
};
export declare type ATEditorProps = Pick<TextInputProps, Exclude<keyof TextInputProps, 'value' | 'onChangeText' | 'onChange'>> & {
    onChange?: (data: ATChangeData) => void;
    formatAtUser?: (user: ATUser) => string;
    matchFormattedTextReg?: RegExp;
    onAt?: () => void;
};
export declare type ATListItem = {
    key: [number, number];
    user: ATUser;
};
