import { TextInputSelectionChangeEventData, TextInputProps } from 'react-native';

export type ATRange = TextInputSelectionChangeEventData['selection'];

export type ATUser = {
  username: string;
  id: string | number;
};

export type ATMap = Map<[number, number], ATUser>;

export type ATChangeData = {
  displayText: string;
  text: string;
  users: ATUser[];
};

export type ATEditorProps = Pick<
  TextInputProps,
  Exclude<keyof TextInputProps, 'value' | 'onChangeText' | 'onChange'>
> & {
  onChange?: (data: ATChangeData) => void;
  formatAtUser?: (user: ATUser) => string;
  matchFormattedTextReg?: RegExp;
  onAt?: () => void;
};

export type ATListItem = {
  key: [number, number];
  user: ATUser;
};
